//
// file      : mdm_demo_cc5x.c
// author    : Ian Forse
// date      : 2002-10-24
// purpose   : Demonstration of Display modes
// includes  : None
// notes     : 
// compiler  : CC5X V3.1f Free Edition C Compiler from BKD
//
// Copyright (C) 2002 Ian Forse
//
// This library is free software; you can redistribute it and/or
// modify it under the terms of the GNU Lesser General Public
// License as published by the Free Software Foundation; either
// version 2.1 of the License, or (at your option) any later version.
//
// This library is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
// Lesser General Public License for more details.

// You should have received a copy of the GNU Lesser General Public
// License along with this library; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307
// USA

// ----------------------------------------------------------------------------
// Blink All Segments
// ----------------------------------------------------------------------------

void blink (void)
{
	signed char i;
	for (i=2; i>=0; i--)
	{
		mdm_all( 0xff );
		DelayMs(250);
		mdm_all( 0x00 );
		DelayMs(250);
	}
}


// ----------------------------------------------------------------------------
// Display 12:34.5 by writing to individual positions
// ----------------------------------------------------------------------------

void show_12345 (void)
{     
	mdm_clear();
	mdm_write_p( 1, '1' );
	mdm_write_p( 2, '2' );
	mdm_write_p( 3, ':' );
	mdm_write_p( 3, '3' );
	mdm_write_p( 4, '4' );
	mdm_write_p( 5, '.' );
	mdm_write_p( 5, '5' );
	DelayMs(250);
	DelayMs(250);
	DelayMs(250);
	DelayMs(250);
}


// ----------------------------------------------------------------------------
// Show all characters
// ----------------------------------------------------------------------------

void show_ascii (void)
{
	unsigned char n = 0;
	unsigned char b;
	while(1)
	{
		b = n/100;
		mdm_write_p( 1, ( 48 + b ));
		b = n/10;
		b = b % 10;
		mdm_write_p( 2, (48 + b ));
		b = (n % 10);
		mdm_write_p( 3, (48 + b ) );
		mdm_write_p( 4, '=' );                 
		mdm_write_p( 5, ' ' );                 
		mdm_write_p( 5, ',' ); 
		mdm_write_p( 5, n );                 
		DelayMs(250);
		n = n + 1;
		if (n == 128) break; //{
	}
}              
                 
                 
// ----------------------------------------------------------------------------
// Show a scrolling message by writing TTY-wise and rotating
// ----------------------------------------------------------------------------

 
void write( char c )
{
	mdm_write( c );
	DelayMs(250);
}


void show_hello (void)
{  
	signed char i;   
	mdm_clear();
	mdm_cursor_position = 5;
	for (i=2; i>=0; i--)
	{
		write( 'H' );
		write( 'E' );
		write( 'L' );
		write( 'L' );
		write( 'O' );
		write( ' ' );
		write( 'W' );
		write( 'O' );
		write( 'R' );
		write( 'L' );
		write( 'D' );
		write( ' ' );
	}
}

// ----------------------------------------------------------------------------
// Blank Display for 1 second
// ----------------------------------------------------------------------------

void blank (void)
{
	mdm_all( 0 );
	DelayMs(250);
	DelayMs(250);
	DelayMs(250);
	DelayMs(250);
}
