//// //////////////////////////////////////////////////////////////////////////
////
//// interface for the Lascar Electronics MDM-1 display
//// segment lookup tables    
//// note: c must be < 128!
////   
//// //////////////////////////////////////////////////////////////////////////
////
//// Copyright (C) 2002 Wouter van Ooijen
////
//// This library is free software// you can redistribute it and/or
//// modify it under the terms of the GNU Library General Public
//// License as published by the Free Software Foundation// either
//// version 2 of the License, or (at your option) any later version.
////
//// This library is distributed in the hope that it will be useful,
//// but WITHOUT ANY WARRANTY// without even the implied warranty of
//// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
//// Library General Public License for more details.
//// 
//// You should have received a copy of the GNU Library General Public
//// License along with this library// if not, write to the
//// Free Software Foundation, Inc., 59 Temple Place - Suite 330,
//// Boston, MA  02111-1307, USA.
////
//// //////////////////////////////////////////////////////////////////////////   
////
//// history
//// 
//// 23-06-2002 first release
////
//// //////////////////////////////////////////////////////////////////////////

unsigned char mdm_lookup_a( unsigned char c )
{
      #asm;                               
      local table_start
      hpage table_start  
      movwf PCLATH
      bank c 
      movfw PCL
      addlw 5
      addwf c, w
      skpnc
         incf PCLATH, f
      movwf PCL
   table_start:
      //         bafcdejo       hex   dec   char
      RETLW   0b_00000000  //  0x00   000   blank 
      RETLW   0b_11100010  //  0x01   001   o (degree)
      RETLW   0b_00011110  //  0x02   002   o (lower case o) 
      RETLW   0b_01000010  //  0x03   003   ohm 
      RETLW   0b_00011100  //  0x04   004   u 
      RETLW   0b_01001010  //  0x05   005   # (pound) 
      RETLW   0b_00010110  //  0x06   006   m 
      RETLW   0b_00000000  //  0x07   007   blank 
      RETLW   0b_00000000  //  0x08   008   blank 
      RETLW   0b_00000000  //  0x09   009   blank 
      RETLW   0b_00000000  //  0x0A   010   blank 
      RETLW   0b_00000000  //  0x0B   011   blank 
      RETLW   0b_00000000  //  0x0C   012   blank 
      RETLW   0b_00000000  //  0x0D   013   blank 
      RETLW   0b_00000000  //  0x0E   014   blank 
      RETLW   0b_00000000  //  0x0F   015   blank 
      RETLW   0b_00000000  //  0x10   016   blank 
      RETLW   0b_00000000  //  0x11   017   blank 
      RETLW   0b_00000000  //  0x12   018   blank 
      RETLW   0b_00000000  //  0x13   019   blank 
      RETLW   0b_00000000  //  0x14   020   blank 
      RETLW   0b_00000000  //  0x15   021   blank 
      RETLW   0b_00000000  //  0x16   022   blank 
      RETLW   0b_00000000  //  0x17   023   blank 
      RETLW   0b_00000000  //  0x18   024   blank 
      RETLW   0b_00000000  //  0x19   025   blank 
      RETLW   0b_00000000  //  0x1A   026   blank 
      RETLW   0b_00000000  //  0x1B   027   blank 
      RETLW   0b_00000000  //  0x1C   028   blank 
      RETLW   0b_00000000  //  0x1D   029   blank 
      RETLW   0b_00000000  //  0x1E   030   blank 
      RETLW   0b_00000000  //  0x1F   031   blank 
      RETLW   0b_00000000  //  0x20   032   space
      RETLW   0b_00001000  //  0x21   033   !
      RETLW   0b_00100000  //  0x22   034   "
      RETLW   0b_00110010  //  0x23   035   #
      RETLW   0b_01111010  //  0x24   036   $
      RETLW   0b_00110010  //  0x25   037   %
      RETLW   0b_00101110  //  0x26   038   &
      RETLW   0b_00000000  //  0x27   039   '
      RETLW   0b_00000000  //  0x28   040   (
      RETLW   0b_00000000  //  0x29   041   )
      RETLW   0b_00000010  //  0x2A   042   *
      RETLW   0b_00000010  //  0x2B   043   +        
      RETLW   0b_00000000  //  0x2C   044   , (clears dots)
      RETLW   0b_00000010  //  0x2D   045   -
      RETLW   0b_00000001  //  0x2E   046   .
      RETLW   0b_00000000  //  0x2F   047   /
      RETLW   0b_11111100  //  0x30   048   0     
      RETLW   0b_10010000  //  0x31   049   1
      RETLW   0b_11001110  //  0x32   050   2
      RETLW   0b_11011000  //  0x33   051   3
      RETLW   0b_10110010  //  0x34   052   4    
      RETLW   0b_01111010  //  0x35   053   5
      RETLW   0b_01111110  //  0x36   054   6
      RETLW   0b_11010000  //  0x37   055   7
      RETLW   0b_11111110  //  0x38   056   8
      RETLW   0b_11111010  //  0x39   057   9
      RETLW   0b_00000000  //  0x3A   058   :
      RETLW   0b_00000001  //  0x3B   059   ;
      RETLW   0b_00000000  //  0x3C   060   <
      RETLW   0b_00001010  //  0x3D   061   =
      RETLW   0b_00000000  //  0x3E   062   >
      RETLW   0b_11100001  //  0x3F   063   ?
      RETLW   0b_11101100  //  0x40   064   @
      RETLW   0b_11110110  //  0x41   065   A    
      RETLW   0b_11011000  //  0x42   066   B
      RETLW   0b_01101100  //  0x43   067   C
      RETLW   0b_11011000  //  0x44   068   D
      RETLW   0b_01101110  //  0x45   069   E
      RETLW   0b_01100110  //  0x46   070   F
      RETLW   0b_01111100  //  0x47   071   G
      RETLW   0b_10110110  //  0x48   072   H
      RETLW   0b_01001000  //  0x49   073   I
      RETLW   0b_10011100  //  0x4A   074   J
      RETLW   0b_00100110  //  0x4B   075   K
      RETLW   0b_00101100  //  0x4C   076   L
      RETLW   0b_10110100  //  0x4D   077   M
      RETLW   0b_10110100  //  0x4E   078   N
      RETLW   0b_11111100  //  0x4F   079   O
      RETLW   0b_11100110  //  0x50   080   P
      RETLW   0b_11111100  //  0x51   081   Q
      RETLW   0b_11100110  //  0x52   082   R
      RETLW   0b_01111010  //  0x53   083   S
      RETLW   0b_01000000  //  0x54   084   T
      RETLW   0b_10111100  //  0x55   085   U
      RETLW   0b_00100100  //  0x56   086   V
      RETLW   0b_10111100  //  0x57   087   W
      RETLW   0b_00000000  //  0x58   088   X
      RETLW   0b_00000000  //  0x59   089   Y
      RETLW   0b_01001000  //  0x5A   090   Z
      RETLW   0b_01101100  //  0x5B   091   [
      RETLW   0b_00000000  //  0x5C   092   \
      RETLW   0b_11011000  //  0x5D   093   ]
      RETLW   0b_00000000  //  0x5E   094   ^
      RETLW   0b_00001000  //  0x5F   095   _
      RETLW   0b_00000000  //  0x60   096   `
      RETLW   0b_11110110  //  0x61   097   a
      RETLW   0b_00111110  //  0x62   098   b
      RETLW   0b_00001110  //  0x63   099   c
      RETLW   0b_10011110  //  0x64   100   d
      RETLW   0b_11101110  //  0x65   101   e
      RETLW   0b_01100110  //  0x66   102   f
      RETLW   0b_11111010  //  0x67   103   g
      RETLW   0b_00100110  //  0x68   104   h
      RETLW   0b_00001010  //  0x69   105   i
      RETLW   0b_10011000  //  0x6A   106   j
      RETLW   0b_00100110  //  0x6B   107   k
      RETLW   0b_00100100  //  0x6C   108   l
      RETLW   0b_00010110  //  0x6D   109   m
      RETLW   0b_00000110  //  0x6E   110   n
      RETLW   0b_00011110  //  0x6F   111   o
      RETLW   0b_11100110  //  0x70   112   p
      RETLW   0b_11110010  //  0x71   113   q
      RETLW   0b_00000000  //  0x72   114   r
      RETLW   0b_00001000  //  0x73   115   s
      RETLW   0b_00101110  //  0x74   116   t
      RETLW   0b_00011100  //  0x75   117   u
      RETLW   0b_00000100  //  0x76   118   v
      RETLW   0b_00010100  //  0x77   119   w
      RETLW   0b_00000000  //  0x78   120   x
      RETLW   0b_10010000  //  0x79   121   y
      RETLW   0b_00001010  //  0x7A   122   z
      RETLW   0b_00000010  //  0x7B   123   {
      RETLW   0b_00000000  //  0x7C   124   |
      RETLW   0b_00000000  //  0x7D   125   }
      RETLW   0b_00110000  //  0x7E   126   ~
      RETLW   0b_11111111  //  0x7F   127   (del)      
#endasm;
}                                    

unsigned char mdm_lookup_b( unsigned char c )
{
      #asm                               
      local table_start
      hpage table_start  
      movwf PCLATH
      bank c 
      movfw PCL
      addlw 5
      addwf c, w
      skpnc
         incf PCLATH, f
      movwf PCL
   table_start:      
      //         ihgnmlkr       hex   dec   char
      RETLW   0b_00000000  //  0x00   000   blank 
      RETLW   0b_11100010  //  0x01   001   o (degree)
      RETLW   0b_00011110  //  0x02   002   o (lower case o) 
      RETLW   0b_01000010  //  0x03   003   ohm 
      RETLW   0b_00011100  //  0x04   004   u 
      RETLW   0b_01001010  //  0x05   005   # (pound) 
      RETLW   0b_00010110  //  0x06   006   m 
      RETLW   0b_00000000  //  0x07   007   blank 
      RETLW   0b_00000000  //  0x08   008   blank 
      RETLW   0b_00000000  //  0x09   009   blank 
      RETLW   0b_00000000  //  0x0A   010   blank 
      RETLW   0b_00000000  //  0x0B   011   blank 
      RETLW   0b_00000000  //  0x0C   012   blank 
      RETLW   0b_00000000  //  0x0D   013   blank 
      RETLW   0b_00000000  //  0x0E   014   blank 
      RETLW   0b_00000000  //  0x0F   015   blank 
      RETLW   0b_00000000  //  0x10   016   blank 
      RETLW   0b_00000000  //  0x11   017   blank 
      RETLW   0b_00000000  //  0x12   018   blank 
      RETLW   0b_00000000  //  0x13   019   blank 
      RETLW   0b_00000000  //  0x14   020   blank 
      RETLW   0b_00000000  //  0x15   021   blank 
      RETLW   0b_00000000  //  0x16   022   blank 
      RETLW   0b_00000000  //  0x17   023   blank 
      RETLW   0b_00000000  //  0x18   024   blank 
      RETLW   0b_00000000  //  0x19   025   blank 
      RETLW   0b_00000000  //  0x1A   026   blank 
      RETLW   0b_00000000  //  0x1B   027   blank 
      RETLW   0b_00000000  //  0x1C   028   blank 
      RETLW   0b_00000000  //  0x1D   029   blank 
      RETLW   0b_00000000  //  0x1E   030   blank 
      RETLW   0b_00000000  //  0x1F   031   blank   
      RETLW   0b_00000000  //  0x20   032   space
      RETLW   0b_01001000  //  0x21   033   !
      RETLW   0b_01000000  //  0x22   034   " 
      RETLW   0b_01001010  //  0x23   035   #
      RETLW   0b_01001010  //  0x24   036   $
      RETLW   0b_11001110  //  0x25   037   %
      RETLW   0b_01001000  //  0x26   038   &
      RETLW   0b_01000000  //  0x27   039   '
      RETLW   0b_10010000  //  0x28   040   (  
      RETLW   0b_00100100  //  0x29   041   ) 
      RETLW   0b_11111110  //  0x2A   042   * 
      RETLW   0b_01001010  //  0x2B   043   +
      RETLW   0b_00000000  //  0x2C   044   , clears dots)
      RETLW   0b_00000010  //  0x2D   045   -
      RETLW   0b_00000000  //  0x2E   046   .
      RETLW   0b_10000100  //  0x2F   047   /
      RETLW   0b_00000000  //  0x30   048   0  
      RETLW   0b_00000000  //  0x31   049   1  
      RETLW   0b_00000010  //  0x32   050   2  
      RETLW   0b_00000010  //  0x33   051   3  
      RETLW   0b_00000010  //  0x34   052   4  
      RETLW   0b_00000010  //  0x35   053   5  
      RETLW   0b_00000010  //  0x36   054   6  
      RETLW   0b_00000000  //  0x37   055   7  
      RETLW   0b_00000010  //  0x38   056   8  
      RETLW   0b_00000010  //  0x39   057   9  
      RETLW   0b_00000001  //  0x3A   058   :  
      RETLW   0b_00000001  //  0x3B   059   ;
      RETLW   0b_10010000  //  0x3C   060   <  
      RETLW   0b_00000010  //  0x3D   061   =  
      RETLW   0b_00100100  //  0x3E   062   >  
      RETLW   0b_00001010  //  0x3F   063   ?  
      RETLW   0b_01000010  //  0x40   064   @  
      RETLW   0b_00000010  //  0x41   065   A  
      RETLW   0b_01001010  //  0x42   066   B  
      RETLW   0b_00000000  //  0x43   067   C  
      RETLW   0b_01001000  //  0x44   068   D  
      RETLW   0b_00000000  //  0x45   069   E  
      RETLW   0b_00000000  //  0x46   070   F  
      RETLW   0b_00000010  //  0x47   071   G  
      RETLW   0b_00000010  //  0x48   072   H  
      RETLW   0b_01001000  //  0x49   073   I          
      RETLW   0b_00000000  //  0x5A   074   J 
      RETLW   0b_10010000  //  0x5B   075   K  
      RETLW   0b_00000000  //  0x5C   076   L  
      RETLW   0b_10100000  //  0x5D   077   M  
      RETLW   0b_00110000  //  0x5E   078   N  
      RETLW   0b_00000000  //  0x5F   079   O  
      RETLW   0b_00000010  //  0x60   080   P  
      RETLW   0b_00010000  //  0x61   081   Q  
      RETLW   0b_00010010  //  0x62   082   R  
      RETLW   0b_00000010  //  0x63   083   S  
      RETLW   0b_01001000  //  0x64   084   T  
      RETLW   0b_0000000   //  0x65   085   U  
      RETLW   0b_10000100  //  0x66   086   V  
      RETLW   0b_00001000  //  0x67   087   W  
      RETLW   0b_10110100  //  0x68   088   X  
      RETLW   0b_10101000  //  0x69   089   Y  
      RETLW   0b_10000100  //  0x6A   090   Z  
      RETLW   0b_00000000  //  0x6B   091   [  
      RETLW   0b_00110000  //  0x6C   092   \  
      RETLW   0b_00000000  //  0x6D   093   ] 
      RETLW   0b_10100000  //  0x6E   094   ^ 
      RETLW   0b_00000000  //  0x6F   095   _        
      RETLW   0b_00100000  //  0x60   096   `
      RETLW   0b_00000010  //  0x61   097   a
      RETLW   0b_00000010  //  0x62   098   b
      RETLW   0b_00000010  //  0x63   099   c
      RETLW   0b_00000010  //  0x64   100   d
      RETLW   0b_00000010  //  0x65   101   e
      RETLW   0b_00000000  //  0x66   102   f
      RETLW   0b_00000010  //  0x67   103   g
      RETLW   0b_00001000  //  0x68   104   h
      RETLW   0b_00001010  //  0x69   105   i
      RETLW   0b_00000000  //  0x6A   106   j
      RETLW   0b_00010010  //  0x6B   107   k
      RETLW   0b_00000000  //  0x6C   108   l
      RETLW   0b_00001010  //  0x6D   109   m
      RETLW   0b_00001000  //  0x6E   110   n
      RETLW   0b_00000010  //  0x6F   111   o
      RETLW   0b_00000010  //  0x70   112   p
      RETLW   0b_00000010  //  0x71   113   q
      RETLW   0b_00001010  //  0x72   114   r
      RETLW   0b_00010010  //  0x73   115   s
      RETLW   0b_00000000  //  0x74   116   t
      RETLW   0b_00000000  //  0x75   117   u
      RETLW   0b_00000100  //  0x76   118   v
      RETLW   0b_00010100  //  0x77   119   w
      RETLW   0b_10110100  //  0x78   120   x
      RETLW   0b_01000010  //  0x79   121   y
      RETLW   0b_00000100  //  0x7A   122   z
      RETLW   0b_10010000  //  0x7B   123   {
      RETLW   0b_01001000  //  0x7C   124   |
      RETLW   0b_00100110  //  0x7D   125   }
      RETLW   0b_00110000  //  0x7E   126   ~
      RETLW   0b_11111111  //  0x7F   127   (del)          
      #endasm;
}